%ifarch ppc ppc64
%define __arch		ppc
%else
%ifarch arm64
%define __arch		arm64
%else
%define __arch		x86_64
%endif
%endif
#%define __use_clang	1
%define __use_clang	0
%define __version       02
%define __release	13.01
%define __osxver	10.15
%define __vername	02-13-01

Summary: A persistency framework defining a data model for linear collider experiments
Name: lcio213
Version: %{__version}.%{__release}
Release: %{__osxver}%{?dist}2b
Source0: localhost:/lcio-v%{version}.tar.gz
Patch0:  localhost:/lcio-v02.07.patch
Patch1:  localhost:/lcio-v02.12.0-macosx10.13.patch
Patch2:  localhost:/lcio-v02.13.01-f77.patch
URL: http://lcio.desy.de/
Group: Development/Libraries
License: Linear Collider Study Group
%define __prefix	/opt/lcio
Prefix: %{__prefix}
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: root

%description
LCIO is a persistency framework that defines a data model for linear 
collider detector studies. It is intended to be used in both simulation 
studies and analysis frameworks. 
Its light weight and portability makes it also suitable for use in 
detector R&D applications. It provides a C++ and a Java implementation 
with a common interface (API) - a Fortran interface to the C++ 
implementation also exists.

Almost all groups involved in linear collider detector studies have their 
own simulation software framework. Using a common persistency scheme 
would allow to easily share results and compare pattern recognition algorithms. 
LCIO (Linear Collider I/O) is such a persistency framework. LCIO is used 
by one US group and will be the standard format for the european simulation 
applications, where others might join in the near future.

The framework fulfills the requirements of the different groups today and 
is flexible enough to be adapted to future needs.

%prep
%setup -q -n LCIO-%{__vername}

%if %{__use_clang}
#%patch0 -p1 -b .osx
%endif
%ifos darwin
%patch1 -p1 -b .osx
%patch2 -p1 -b .f77
%endif
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'`

%build
rootdir=`rpm -ql root | grep thisroot.sh | tail -1 | sed -e 's;/bin/thisroot.sh;;'`
pushd ${rootdir}
  source `rpm -ql root | grep thisroot.sh | tail -1`
popd

mkdir build
cd build
export CLHEP_DIR=`rpm -ql clhep | grep clhep-config | tail -1 | sed -e 's;/bin/clhep-config;;'` 

%if %{__use_clang}
cmake -DBUILD_ROOTDICT=ON -DINSTALL_JAR=OFF -DCLHEP_DIR=$CLHEP_DIR -DBUILD_LCIO_EXAMPLES=ON -DBUILD_F77_TESTJOBS=ON -DCMAKE_INSTALL_PREFIX=%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'` -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ ..
%else
cmake -DBUILD_ROOTDICT=ON -DINSTALL_JAR=OFF -DCLHEP_DIR=$CLHEP_DIR -DBUILD_LCIO_EXAMPLES=ON -DBUILD_F77_TESTJOBS=ON -DCMAKE_INSTALL_PREFIX=%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'` -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++ -DCMAKE_CXX_FLAGS='-std=c++17' -DCMAKE_Fortran_FLAGS='-fallow-invalid-boz' ..
%endif
make %{?_smp_mflags}

# fix paths to config files
mv LCIOConfig.cmake LCIOConfig.cmake.orig
sed -e 's;\(.*\)/Users/.*/LCIO-\([0-9]*\)-\([0-9]*\)-\([0-9]*\)\(.*\);\1/opt/lcio/v\2-\3-\4\5;' LCIOConfig.cmake.orig > LCIOConfig.cmake
mv LCIOConfigVersion.cmake LCIOConfigVersion.cmake.orig
sed -e 's;\(.*\)/Users/.*/LCIO-\([0-9]*\)-\([0-9]*\)-\([0-9]*\)\(.*\);\1/opt/lcio/v\2-\3-\4\5;' LCIOConfigVersion.cmake.orig > LCIOConfigVersion.cmake


%install
mkdir -p $RPM_BUILD_ROOT%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'`
(
cd build
make install DESTDIR=$RPM_BUILD_ROOT
)

cd %{_builddir}/LCIO-%{__vername}
cp -RPp cmake $RPM_BUILD_ROOT%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'`

echo "%exclude %{prefix}*/.svn/*" > list.f
echo "%exclude %{prefix}*/.svn" >> list.f
find $RPM_BUILD_ROOT -type d | sed -e "s;$RPM_BUILD_ROOT;%dir ;" \
			     | grep -ve '^%dir %{prefix}$' \
			     | grep -ve '^%dir /[^/]*$'  \
			     | grep -ve '^%dir $' >> list.f
find $RPM_BUILD_ROOT -type f | sed -e "s;$RPM_BUILD_ROOT;;" >> list.f
find $RPM_BUILD_ROOT -type l | sed -e "s;$RPM_BUILD_ROOT;;" >> list.f

%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{_builddir}/LCIO-%{__vername}/list.f
%defattr(-,root,wheel)

%changelog
* Sun Feb 27 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 02-13-01-12hepx2b
- 2nd build and release on MacOS 12 for M1 Macs with clhep-2.4.5.1
- package renamed "lcio213" to allow coexistence with clang version.
- built with OSXWS 12beta and gcc11 without JAR

* Sat Feb 26 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 02-13-01-12hepx2a
- 1st build and release on MacOS 12 for M1 Macs with clhep-2.4.5.1
- package renamed "lcio213" to allow coexistence with clang version.
- built with OSXWS 11 and gcc11 without JAR

* Fri Feb 25 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 02-13-01-12hepx2a
- 1st build and release on MacOS 12 for M1 Macs with clhep-2.4.5.1
- built with OSXWS 11 and gcc11 without JAR

* Fri Jan 24 2020 Keisuke Fujii <keisuke.fujii@kek.jp> 02-13-01-10.15hepx2a
- 1st build and release on MacOS X 10.15 for Intel Macs with clhep-2.4.1.3
- built with OSXWS 10.15

* Sun Dec 29 2019 Keisuke Fujii <keisuke.fujii@kek.jp> 02-13-01-10.14hepx2a
- 1st build and release on MacOS X 10.14 for Intel Macs with clhep-2.4.1.3
- built with OSXWS 10.14

* Sat Dec 28 2019 Keisuke Fujii <keisuke.fujii@kek.jp> 02-12-0-10.14hepx1b
- 2nd build and release on MacOS X 10.14 for Intel Macs with clhep-2.4.0.4
- built with OSXWS 10.14

* Tue Dec 25 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 02-12-0-10.14hepx1a
- 1st build and release on MacOS X 10.14 for Intel Macs with clhep-2.4.0.4
- built with OSXWS 10.13

* Tue Apr 03 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 02-12-0-10.13hepx1a
- 1st build and release on MacOS X 10.13 for Intel Macs with clhep-2.4.0.4
- added macosx10.13 patch

* Thu Jan 26 2017 Keisuke Fujii <keisuke.fujii@kek.jp> 02-07-04-10.12hepx1a
- 1st build and release on MacOS X 10.12 for Intel Macs with clhep-2.3.4.3

- rebuilt with OSXWS 10.12.
* Tue Dec 27 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 02-07-03-10.12hepx1b
- 2nd build and release on MacOS X 10.12 for Intel Macs with clhep-2.3.4.3
- rebuilt with OSXWS 10.12.

* Mon Dec 19 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 02-07-03-10.12hepx1a
- 1st build and release on MacOS X 10.12 for Intel Macs with clhep-2.3.4.3
- built with OSXWS 10.11.

* Thu Nov 17 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 02-07-03-10.11hepx1a
- 1st build and release on MacOS X 10.11 for Intel Macs with clhep-2.3.1.1
- built with g++5.3.

* Tue Oct 11 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 02-07-02-10.10hepx1a
- 1st build and release on MacOS X 10.10 for Intel Macs with clhep-2.3.1.1
- built with g++4.9.

* Wed Dec 24 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 02-05-10.10hepx4a
- 1st build and release on MacOS X 10.10 for Intel Macs with clhep-2.2.0.1

* Sat Sep 13 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 02-05-10.9hepx4a
- 2nd build and release on MacOS X 10.9 for Intel Macs with clhep-2.2.0.1
- Activated "INSTALL_JAR" flag and fixed the paths to config files

* Fri Sep 12 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 02-05-10.9hepx3a
- 1st build and release on MacOS X 10.9 for Intel Macs with clhep-2.2.0.1

* Thu Aug 07 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 02-04-03-10.9hepx3b
- 1st build and release on MacOS X 10.9 for Intel Macs with clhep-2.2.0.1

* Thu Dec 26 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 02-04-03-10.9hepx3a
- 1st build and release on MacOS X 10.9 for Intel Macs with clhep-2.1.4.3

* Fri Dec 20 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 02-04-02-10.9hepx3b
- 4th build and release on MacOS X 10.9 for Intel Macs with clhep-2.1.4.2
- now linked against root-5.34.14.

* Sun Dec 01 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 02-04-02-10.9hepx3a
- 3rd build and release on MacOS X 10.9 for Intel Macs with clhep-2.1.4.2
- changed installation name to /opt/lcio/v02-04-02

* Sat Nov 30 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 02-04-02-10.9hepx2a
- 2nd build and release on MacOS X 10.9 for Intel Macs with clhep-2.1.4.2
- now build automatically

* Sat Nov 30 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 02-04-02-10.9hepx1a
- 1st build on MacOS X 10.9 for Intel Macs with clhep-2.1.4.2

* Wed Oct 31 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 02-03-01-10.7hepx1a
- 1st build on MacOS X 10.7 for Intel Macs with clhep-2.1.3.1

* Thu May 03 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 02-01.01-10.7hepx1a
- 1st build on MacOS X 10.7 for Intel Macs with clhep-2.1.2.2
- now built for x86_64

* Wed May 02 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 02-00-10.7hepx1a
- 1st build on MacOS X 10.7 for Intel Macs with clhep-2.1.2.2
- now built for x86_64

* Wed Oct 12 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 02-00-10.6hepx1f
- 1st build on MacOS X 10.7 for Intel Macs with clhep-2.1.1.0
- rebuilt with gcc4.5.1 and libstdc++.dylib and root_v5.30.02-1c

* Tue Oct 11 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 02-00-10.6hepx1e
- 2nd build on MacOS X 10.6 for Intel Macs with clhep-2.1.1.0
- rebuilt with gcc4.5.1 and libstdc++.dylib and root_v5.30.02-1b

* Sun Sep 25 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 02-00-10.6hepx1d
- 1st build on MacOS X 10.6 for Intel Macs with clhep-2.1.1.0
- built with gcc4.5.1 and libstdc++.dylib

* Wed Jan 26 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 01-51-10.6hepx1d
- 4th build on MacOS X 10.6 for Intel Macs with clhep-2.1.0.1
- rebuilt with gcc4.5.1 and libstdc++.dylib

* Sun Nov 14 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 01-51-10.6hepx1c
- 3rd build on MacOS X 10.6 for Intel Macs with clhep-2.0.4.6
- rebuilt with gcc4.5.1

* Fri Oct 01 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 01-51-10.6hepx1b
- 2nd build on MacOS X 10.6 for PPC Macs with clhep-2.0.4.6
- rebuilt with gcc4.5.1

* Mon Sep 13 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 01-51-10.6hepx1a
- 1st build on MacOS X 10.6 for PPC Macs with clhep-2.0.4.6

* Tue Mar 09 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 01-12.2-10.6hepx1b
- 2nd build on MacOS X 10.6 for PPC Macs with clhep-2.0.4.5
- added symlinks for top-level include and libsio

* Mon Mar 08 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 01-12.2-10.6hepx1a
- 1st build on MacOS X 10.6 for PPC Macs with clhep-2.0.4.5

* Thu Jan 15 2009 Keisuke Fujii <keisuke.fujii@kek.jp> 01-11-10.5hepx1a
- 1st build on MacOS X 10.5 for PPC Macs with clhep-2.0.4.2

* Tue Sep 23 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 01-10-10.5hepx1b
- 1st build on MacOS X 10.5 for PPC Macs with clhep-2.0.4.0

* Fri Jul 4 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 01-10-10.5hepx1a
- 1st build on MacOS X 10.5 for PPC Macs with clhep-2.0.3.3

* Thu Mar 27 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 01-09-10.5hepx1b
- 1st build on MacOS X 10.5 for PPC Macs with clhep-2.0.3.2

* Wed Mar 26 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 01-09-10.5hepx1a
- 1st build on MacOS X 10.5 for Intel Macs with clhep-2.0.3.2

